<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchUsuariosGrupo"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
            </v-toolbar>
            <v-list
              height="300"
              max-height="300"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader>USUARIOS DEL GRUPO</v-subheader>
              <v-list-item-group
                v-model="selectedUsuariosGrupo"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedUsuariosGrupo"
                  :key="indexItem"
                >
                  <template v-slot:default="{ active }">
                    <v-list-item-avatar>
                      <v-icon large>mdi-account-circle-outline</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title>
                        <router-link
                          class="text-decoration-underline"
                          :to="toUsuario(item.usuario)"
                        >
                          {{ item.usuario.nombre }}
                        </router-link>
                      </v-list-item-title>
                      <v-list-item-subtitle
                        v-text="item.usuario.numeroEmpleado"
                      ></v-list-item-subtitle>
                    </v-list-item-content>
                    <v-list-item-action>
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            class="white--text"
                            color="grey"
                            v-bind="attrs"
                            v-on="on"
                            @click="deleteUsuarioGrupo(indexItem, item)"
                          >
                            <v-icon>mdi-account-arrow-right-outline</v-icon>
                          </v-btn>
                        </template>
                        <span
                          >Eliminar del grupo a {{ item.usuario.nombre }}</span
                        >
                      </v-tooltip>
                    </v-list-item-action>
                  </template>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchUsuariosDisponibles"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
            </v-toolbar>
            <v-list
              height="300"
              max-height="400"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader>USUARIOS PARA UNIRSE</v-subheader>
              <v-list-item-group
                v-model="selectedUsuariosDisponibles"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedUsuariosDisponibles"
                  :key="indexItem"
                >
                  <v-list-item-avatar>
                    <v-icon large>mdi-account-circle-outline</v-icon>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <v-list-item-title>
                      <router-link
                        class="text-decoration-underline"
                        :to="toUsuario(item.usuario)"
                      >
                        {{ item.usuario.nombre }}
                      </router-link>
                    </v-list-item-title>
                    <v-list-item-subtitle
                      v-text="item.usuario.numeroEmpleado"
                    ></v-list-item-subtitle>
                  </v-list-item-content>
                  <v-list-item-action>
                    <v-tooltip bottom>
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          class="white--text"
                          color="grey"
                          v-bind="attrs"
                          v-on="on"
                          @click="postUsuarioGrupo(indexItem, item)"
                        >
                          <v-icon>mdi-account-arrow-left-outline</v-icon>
                        </v-btn>
                      </template>
                      <span>Unir al grupo</span>
                    </v-tooltip>
                  </v-list-item-action>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Usuarios",
  props: ["grupoIn"],
  data() {
    return {
      searchUsuariosGrupo: null,
      searchUsuariosDisponibles: null,
      selectedUsuariosGrupo: null,
      selectedUsuariosDisponibles: null,
      usuariosGrupo: [],
      usuariosDisponibles: [],
      grupo: null,
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchedUsuariosDisponibles() {
      let tempData = this.usuariosDisponibles;
      if (
        this.searchUsuariosDisponibles != "" &&
        this.searchUsuariosDisponibles
      ) {
        tempData = tempData.filter((item) => {
          return JSON.stringify(item)
            .toUpperCase()
            .includes(this.searchUsuariosDisponibles.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.usuario.nombre.toLowerCase();
          let fb = b.usuario.nombre.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
    searchedUsuariosGrupo() {
      let tempData = this.usuariosGrupo;
      if (this.searchUsuariosGrupo != "" && this.searchUsuariosGrupo) {
        tempData = tempData.filter((item) => {
          return JSON.stringify(item)
            .toUpperCase()
            .includes(this.searchUsuariosGrupo.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.usuario.nombre.toLowerCase();
          let fb = b.usuario.nombre.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    toUsuario(usuario) {
      return {
        name: "modelo_negocio_accesos_usuarios_edicion",
        params: {
          usuario: this.serviceCommons.objectToBase64(usuario),
        },
      };
    },
    deleteUsuarioGrupo(indexItem, usuarioGrupo) {
      axios
        .delete(
          "/modelo-negocio/accesos/grupos/v1/" +
            this.grupo.idGrupo +
            "/usuarios/" +
            usuarioGrupo.idGrupoUsuario
        )
        .then((response) => {
          usuarioGrupo.idGrupoUsuario = null;
          this.usuariosGrupo.splice(indexItem, 1);
          this.usuariosDisponibles.push(usuarioGrupo);
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {});
    },
    postUsuarioGrupo(indexItem, usuarioGrupo) {
      let body = {
        numeroEmpleado: usuarioGrupo.usuario.numeroEmpleado,
      };
      axios
        .post(
          "/modelo-negocio/accesos/grupos/v1/" +
            this.grupo.idGrupo +
            "/usuarios",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            usuarioGrupo.idGrupoUsuario = data.resultado.id;
            this.usuariosGrupo.push(usuarioGrupo);
            this.usuariosDisponibles.splice(indexItem, 1);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {});
    },
    getUsuariosGrupo() {
      this.loading = true;
      axios(
        "/modelo-negocio/accesos/grupos/v1/" + this.grupo.idGrupo + "/usuarios"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.usuariosGrupo = data.resultado.usuarios;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.usuariosGrupo = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
    getUsuariosDisponibles() {
      this.loading = true;
      axios(
        "/modelo-negocio/accesos/grupos/v1/" +
          this.grupo.idGrupo +
          "/usuarios/disponibles"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.usuariosDisponibles = data.resultado.usuarios;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.usuariosDisponibles = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
  created() {
    this.grupo = this.grupoIn;
    this.getUsuariosGrupo();
    this.getUsuariosDisponibles();
  },
};
</script>
